package benefactorkindboxreqservice

import (
	"context"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box_req"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) Delete(ctx context.Context, req param.KindBoxReqDeleteRequest) (param.KindBoxReqDeleteResponse, error) {
	const op = richerror.Op("benefactorkindboxreqservice.Delete")
	if fieldErrors, vErr := s.vld.ValidateDeleteRequest(ctx, req); vErr != nil {
		return param.KindBoxReqDeleteResponse{FieldErrors: fieldErrors}, richerror.New(op).WithErr(vErr)
	}
	dErr := s.repo.DeleteKindBoxReqByID(ctx, req.KindBoxReqID)
	if dErr != nil {
		return param.KindBoxReqDeleteResponse{}, richerror.New(op).WithErr(dErr).WithKind(richerror.KindUnexpected)
	}

	return param.KindBoxReqDeleteResponse{}, nil
}
